Subject: Re: RFC: Allow 'ip' to run in daemon mode?

From: Ben Greear <[email-masked]>
Date: Wed, 30 Jun 2010 09:01:26 -0700

On 06/30/2010 12:00 AM, Stephen Hemminger wrote:
> write a new service rather than bloating the existing code or just use netlink or libnl

I find netlink code a pain to deal with, so I'd like to leverage
existing and ongoing support in iproute.

Would you at least consider the changes in 1) and 2)
so that the new project can continue to use iproute as upstream
w/out significant merge issues?  Those changes shouldn't
significantly add to the code, I believe.

Thanks,
Ben

>
> Ben Greear<[email-masked]>  wrote:
>
>> I'm considering modifying 'ip' to be able to run in daemon
>> mode so that I can do lots of IP commands without having to
>> pay the startup cost of iproute.
>>
>> The -batch option almost works, but it's hard to programatically
>> figure out failure codes.
>>
>> I'm thinking about making these changes:
>>
>> 1)  Move all of the error printing code into common methods (basically,
>>     wrap printf).  In daemon mode this text can be sent back to the
>>     calling process, and in normal mode, it will be printed to stdout/stderr
>>     as it is currently.
>>
>> 2)  Remove all or most calls to 'exit' and instead return error codes
>>     to the calling logic.
>>
>> 3)  Add ability to listen on a unix socket for commands, basically treat
>>     them just like batch commands, one command per packet.
>>
>> 4)  Return well formatted error code and text response to calling process
>>     over the unix socket, maybe something like:
>>
>> RV: [errno or equiv, zero for success]\n
>> CMD: [ command string this relates to ]\n
>> [ Optional free form text ]
>>
>>
>> Does something like this have any chance of upstream inclusion?
>>
>> Thanks,
>> Ben
>>
>> --
>> Ben Greear<[email-masked]>
>> Candela Technologies Inc  http://www.candelatech.com
> N�����r��y���b�X��ǧv�^�)޺{.n�+���z�^�)���w*jg��������ݢj/���z�ޖ��2�ޙ���&�)ߡ�a�����G���h��j:+v���w�٥

-- 
Ben Greear <[email-masked]>
Candela Technologies Inc  http://www.candelatech.com